(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('date-fns'), require('date-fns/locale'), require('@angular/common'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-airbnb-calendar', ['exports', '@angular/core', '@angular/forms', 'date-fns', 'date-fns/locale', '@angular/common', 'rxjs'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-airbnb-calendar'] = {}, global.ng.core, global.ng.forms, global.dateFns, global.dateFnsLocale, global.ng.common, global.rxjs));
}(this, (function (exports, core, forms, dateFns, locale, common, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function mergeCalendarOptions(opts) {
        return Object.assign(Object.assign({}, defaultOptions), opts);
    }
    var defaultOptions = {
        minYear: dateFns.getYear(new Date()) - 30,
        maxYear: dateFns.getYear(new Date()) + 30,
        format: 'yyyy/LL/dd',
        formatTitle: 'MMMM uuuu',
        formatDays: 'eeeeee',
        firstCalendarDay: 0,
        locale: locale.enUS,
        closeOnSelected: false
    };

    var AirbnbCalendarComponent = /** @class */ (function () {
        function AirbnbCalendarComponent(elementRef, cd) {
            this.elementRef = elementRef;
            this.cd = cd;
            this.modelValue = new core.EventEmitter();
            this.fromValue = new core.EventEmitter();
            this.toValue = new core.EventEmitter();
            this.date = new Date();
            this.innerValue = null;
            this.isOpened = false;
            this.fromToDate = { from: null, to: null };
            this.onTouchedCallback = function () { };
            this.onChangeCallback = function () { };
        }
        Object.defineProperty(AirbnbCalendarComponent.prototype, "value", {
            get: function () {
                return this.innerValue;
            },
            set: function (val) {
                this.innerValue = val;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(AirbnbCalendarComponent.prototype, "controlsStatus", {
            get: function () {
                return {
                    from: Boolean(this.options.minYear && this.options.minYear < this.calendar.year && this.calendar.month !== 0),
                    to: Boolean(this.options.maxYear && this.options.maxYear > this.calendarNext.year && this.calendarNext.month !== 11)
                };
            },
            enumerable: false,
            configurable: true
        });
        AirbnbCalendarComponent.prototype.writeValue = function (val) {
            this.innerValue = val;
        };
        AirbnbCalendarComponent.prototype.registerOnChange = function (fn) {
            this.onChangeCallback = fn;
        };
        AirbnbCalendarComponent.prototype.registerOnTouched = function (fn) {
            this.onTouchedCallback = fn;
        };
        AirbnbCalendarComponent.prototype.ngOnInit = function () {
            this.options = mergeCalendarOptions(this.options);
            this.initCalendar();
        };
        AirbnbCalendarComponent.prototype.ngOnChanges = function () {
            this.options = mergeCalendarOptions(this.options);
            this.initCalendar();
        };
        AirbnbCalendarComponent.prototype.selectDay = function (index, calendar) {
            var _this = this;
            if (index) {
                var cal = calendar === 'primary' ? this.calendar : this.calendarNext;
                if (!this.fromToDate.from) {
                    this.fromToDate.from = cal.days[index].date;
                    var from = dateFns.format(this.fromToDate.from, this.options.format);
                    this.value = from;
                    this.modelValue.next(from);
                    this.fromValue.next(from);
                }
                else if (this.fromToDate.from && !this.fromToDate.to) {
                    this.fromToDate.to = cal.days[index].date;
                    var from = dateFns.format(this.fromToDate.from, this.options.format);
                    var to = dateFns.format(this.fromToDate.to, this.options.format);
                    this.value = from + "-" + to;
                    this.modelValue.next(this.value);
                    this.toValue.next(this.value);
                    if (this.options.closeOnSelected) {
                        this.isOpened = false;
                    }
                }
                else if (this.fromToDate.to) {
                    this.fromToDate = { from: cal.days[index].date, to: null };
                    var from = dateFns.format(this.fromToDate.from, this.options.format);
                    this.value = from;
                    this.modelValue.next(from);
                    this.fromValue.next(from);
                }
            }
            this.calendar.days = this.calendar.days.map(function (d) {
                return Object.assign(Object.assign({}, d), {
                    isIncluded: dateFns.isAfter(d.date, _this.fromToDate.from || new Date()) && dateFns.isBefore(d.date, _this.fromToDate.to || new Date()),
                    isActive: dateFns.isSameDay(_this.fromToDate.from || new Date(), d.date) || dateFns.isSameDay(_this.fromToDate.to, d.date)
                });
            });
            this.calendarNext.days = this.calendarNext.days.map(function (d) {
                return Object.assign(Object.assign({}, d), {
                    isIncluded: dateFns.isAfter(d.date, _this.fromToDate.from || new Date()) && dateFns.isBefore(d.date, _this.fromToDate.to || new Date()),
                    isActive: dateFns.isSameDay(_this.fromToDate.from || new Date(), d.date) || dateFns.isSameDay(_this.fromToDate.to, d.date)
                });
            });
        };
        AirbnbCalendarComponent.prototype.nextMonth = function () {
            this.date = dateFns.addMonths(this.date, 1);
            this.initCalendar();
            this.selectDay();
        };
        AirbnbCalendarComponent.prototype.prevMonth = function () {
            this.date = dateFns.subMonths(this.date, 1);
            this.initCalendar();
            this.selectDay();
        };
        AirbnbCalendarComponent.prototype.initCalendar = function () {
            var date = new Date(this.date.getTime());
            this.calendar = this.generateCalendar(date);
            this.calendarNext = this.generateCalendar(dateFns.addMonths(date, 1));
        };
        AirbnbCalendarComponent.prototype.generateCalendar = function (date) {
            var _this = this;
            if (date === void 0) { date = new Date(); }
            var _a = __read([
                dateFns.setHours(dateFns.startOfMonth(date), 0),
                dateFns.setHours(dateFns.endOfMonth(date), 0),
                dateFns.setSeconds(dateFns.setMinutes(dateFns.setHours(new Date(), 0), 0), 0)
            ], 3), start = _a[0], end = _a[1], now = _a[2];
            var days = dateFns.eachDayOfInterval({ start: start, end: end })
                .map(function (d) {
                d = dateFns.setSeconds(dateFns.setMinutes(dateFns.setHours(d, 0), 0), 0);
                return {
                    date: d,
                    day: dateFns.getDate(d),
                    month: dateFns.getMonth(d),
                    year: dateFns.getYear(d),
                    isSameMonth: dateFns.isSameMonth(d, start),
                    isToday: dateFns.isToday(d),
                    isSelectable: dateFns.isBefore(now, d) || dateFns.isSameDay(now, d),
                    isSelected: false,
                    isVisible: true,
                    isIncluded: dateFns.isAfter(d, _this.fromToDate.from || new Date()) && dateFns.isBefore(d, _this.fromToDate.to || new Date()),
                    isActive: false
                };
            })
                .reduce(function (acc, curr, index, arr) {
                var first = _this.options.firstCalendarDay || 0;
                var tmp = dateFns.getDay(start) - first;
                if (tmp > 0 && arr.length - 1 === index) {
                    acc.unshift.apply(acc, __spread(__spread(new Array(tmp)).map(function (_, i) {
                        var curr = dateFns.setSeconds(dateFns.setMinutes(dateFns.setHours(dateFns.subDays(start, i + 1), 0), 0), 0);
                        return {
                            date: curr,
                            day: dateFns.getDate(curr),
                            month: dateFns.getMonth(curr),
                            year: dateFns.getYear(curr),
                            isSameMonth: false,
                            isToday: false,
                            isSelectable: false,
                            isSelected: false,
                            isVisible: true,
                            isIncluded: dateFns.isAfter(curr, _this.fromToDate.from || new Date()) && dateFns.isBefore(curr, _this.fromToDate.to || new Date()),
                            isActive: false
                        };
                    })));
                }
                return acc.concat(curr);
            }, [])
                .sort(function (a, b) { return (a.date >= b.date ? 1 : -1); });
            var dayNames = [];
            var dayStart = this.options.firstCalendarDay || 0;
            for (var i = dayStart; i <= 6 + dayStart; i++) {
                var date_1 = dateFns.setDay(new Date(), i);
                dayNames.push(dateFns.format(date_1, this.options.formatDays || 'eeeeee', { locale: this.options.locale }));
            }
            return {
                month: dateFns.getMonth(date),
                year: dateFns.getYear(date),
                title: dateFns.format(date, this.options.formatTitle || 'MMMM uuuu', { locale: this.options.locale }),
                days: days,
                dayNames: dayNames
            };
        };
        return AirbnbCalendarComponent;
    }());
    AirbnbCalendarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'airbnb-calendar',
                    template: "<div class=\"airbnb-calendar-container\" *ngIf=\"isOpened\">\n  <div class=\"airbnb-calendar\">\n    <section class=\"calendar\">\n      <div class=\"controls\">\n        <svg\n          xmlns=\"http://www.w3.org/2000/svg\"\n          width=\"8\"\n          height=\"14\"\n          class=\"chevron-left\"\n          (click)=\"prevMonth()\"\n          [class.is-disabled]=\"!controlsStatus.from\"\n        >\n          <path d=\"M2.414 7l5.293 5.293a1 1 0 01-1.414 1.414l-6-6a1 1 0 010-1.414l6-6a1 1 0 011.414 1.414L2.414 7z\" />\n        </svg>\n        <span class=\"month-name\">{{ calendar.title }}</span>\n      </div>\n      <div class=\"calendar-day-names\">\n        <span *ngFor=\"let name of calendar.dayNames\" class=\"day\">{{ name }}</span>\n      </div>\n      <div class=\"calendar-days\">\n        <span\n          *ngFor=\"let day of calendar.days; let i = index\"\n          [ngClass]=\"{\n            day: true,\n            'is-prev-month': !day.isSameMonth,\n            'is-today': day.isToday,\n            'is-selected': day.isSelected,\n            'is-disabled':\n              !day.isSelectable ||\n              ({}.toString.call(this.options.maxDate) === '[object Date]' ? this.options.maxDate! < day.date : false) ||\n              ({}.toString.call(this.options.minDate) === '[object Date]' ? this.options.minDate! > day.date : false),\n            'is-included': day.isIncluded,\n            'is-invisible': !day.isVisible,\n            'is-active': day.isActive || fromToDate.from === day.date || fromToDate.to === day.date\n          }\"\n          (click)=\"selectDay(i, 'primary')\"\n        >\n          {{ day.day }}\n        </span>\n      </div>\n    </section>\n    <section class=\"calendar\">\n      <div class=\"controls\">\n        <span class=\"month-name\">{{ calendarNext.title }}</span>\n        <svg\n          xmlns=\"http://www.w3.org/2000/svg\"\n          width=\"8\"\n          height=\"14\"\n          class=\"chevron-right\"\n          (click)=\"nextMonth()\"\n          [class.is-disabled]=\"!controlsStatus.to\"\n        >\n          <path d=\"M5.586 7L.293 12.293a1 1 0 001.414 1.414l6-6a1 1 0 000-1.414l-6-6A1 1 0 00.293 1.707L5.586 7z\" />\n        </svg>\n      </div>\n      <div class=\"calendar-day-names\">\n        <span *ngFor=\"let name of calendarNext.dayNames\" class=\"day\">{{ name }}</span>\n      </div>\n      <div class=\"calendar-days\">\n        <span\n          *ngFor=\"let day of calendarNext.days; let i = index\"\n          class=\"day\"\n          [ngClass]=\"{\n            'is-disabled':\n              !day.isSelectable ||\n              ({}.toString.call(this.options.maxDate) === '[object Date]' ? this.options.maxDate! < day.date : false) ||\n              ({}.toString.call(this.options.minDate) === '[object Date]' ? this.options.minDate! > day.date : false),\n            'is-prev-month': !day.isSameMonth,\n            'is-today': day.isToday,\n            'is-selected': day.isSelected,\n            'is-included': day.isIncluded,\n            'is-invisible': !day.isVisible,\n            'is-active': day.isActive || fromToDate.from === day.date || fromToDate.to === day.date\n          }\"\n          (click)=\"selectDay(i, 'secondary')\"\n        >\n          {{ day.day }}\n        </span>\n      </div>\n    </section>\n  </div>\n</div>\n",
                    providers: [{ provide: forms.NG_VALUE_ACCESSOR, useExisting: AirbnbCalendarComponent, multi: true }],
                    styles: [":host{box-sizing:border-box;display:block;position:relative;z-index:10}:host *,:host :after,:host :before{box-sizing:inherit}.airbnb-calendar-container{background:#fff;border-radius:4px;box-shadow:1px 2px 3px rgba(0,0,0,.05);display:block;height:380px;left:0;position:absolute;top:5px;width:850px}.airbnb-calendar-container .airbnb-calendar{border:1px solid #eaedf3;border-radius:4px;display:block;height:100%;width:100%}.airbnb-calendar-container .airbnb-calendar .calendar{float:left;height:100%;padding:40px 60px;width:50%}.airbnb-calendar-container .airbnb-calendar .calendar .controls{-moz-user-select:none;-ms-user-select:none;-webkit-user-select:none;align-items:center;display:flex;justify-content:center;margin-bottom:25px;position:relative;user-select:none;width:100%}.airbnb-calendar-container .airbnb-calendar .calendar .controls .month-name{font-size:15px;font-weight:600}.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-left,.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-right{cursor:pointer;height:14px;position:absolute;top:0;width:8px}.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-left.is-disabled,.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-right.is-disabled{cursor:not-allowed;pointer-events:none}.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-left{left:0}.airbnb-calendar-container .airbnb-calendar .calendar .controls .chevron-right{right:0}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-day-names{align-items:center;display:flex;margin-bottom:10px;width:100%}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-day-names .day{-moz-user-select:none;-ms-user-select:none;-webkit-user-select:none;color:#717171;font-size:12px;font-weight:500;text-align:center;user-select:none;width:14.28571%}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days{display:block;width:100%}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day{-moz-user-select:none;-ms-user-select:none;-webkit-user-select:none;align-items:center;border:2px solid transparent;border-radius:50%;color:#222;display:flex;float:left;font-size:14px;font-weight:500;justify-content:center;margin:2px 0;position:relative;user-select:none;width:14.28571%}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day:before{content:\"\";display:block;padding-top:100%}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day:hover:not(.is-disabled){border-color:#222;border-radius:50%;cursor:pointer}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day.is-disabled{color:#d6d6d6;pointer-events:none}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day.is-prev-month{color:transparent}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day.is-active{background:#222;border-color:#222;color:#fff}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day.is-included{background:#f7f7f7;border-color:#f7f7f7;border-radius:0;color:#222}.airbnb-calendar-container .airbnb-calendar .calendar .calendar-days .day.is-invisible{visibility:hidden}"]
                },] }
    ];
    AirbnbCalendarComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef }
    ]; };
    AirbnbCalendarComponent.propDecorators = {
        options: [{ type: core.Input }],
        modelValue: [{ type: core.Output }],
        fromValue: [{ type: core.Output }],
        toValue: [{ type: core.Output }]
    };

    var AirbnbCalendarDirective = /** @class */ (function () {
        function AirbnbCalendarDirective(cfr, vc, el, ngModel) {
            var _this = this;
            this.cfr = cfr;
            this.vc = vc;
            this.el = el;
            this.ngModel = ngModel;
            this.sub = new rxjs.Subscription();
            this.componentFactory = this.cfr.resolveComponentFactory(AirbnbCalendarComponent);
            this.vc.clear();
            this.component = this.vc.createComponent(this.componentFactory);
            this.sub.add(this.component.instance.modelValue.subscribe(function (event) {
                _this.ngModel.control.patchValue(event);
            }));
            this.component.onDestroy(function () { return _this.sub.unsubscribe(); });
        }
        AirbnbCalendarDirective.prototype.ngOnChanges = function () {
            this.component.instance.options = mergeCalendarOptions(this.options);
            this.component.instance.cd.detectChanges();
        };
        AirbnbCalendarDirective.prototype.onFocus = function () {
            this.component.instance.isOpened = true;
        };
        AirbnbCalendarDirective.prototype.onBlurClick = function (e) {
            var container = this.el.nativeElement.parentElement.querySelector('.airbnb-calendar-container');
            var controls = this.el.nativeElement.parentElement.querySelectorAll('.controls');
            if (this.component.instance.fromToDate.from &&
                this.component.instance.fromToDate.to &&
                container &&
                e.target &&
                (container === e.target || container.contains(e.target)) &&
                [].findIndex.call(controls, function (ctrl) { return ctrl.contains(e.target); }) === -1) {
                this.component.instance.fromToDate = { from: null, to: null };
                this.component.instance.value = null;
                this.component.instance.modelValue.next('');
                this.component.instance.fromValue.next('');
                this.component.instance.toValue.next('');
                this.component.instance.calendar.days = this.component.instance.calendar.days.map(function (d) { return (Object.assign(Object.assign({}, d), { isIncluded: false, isActive: false })); });
                this.component.instance.calendarNext.days = this.component.instance.calendarNext.days.map(function (d) { return (Object.assign(Object.assign({}, d), { isIncluded: false, isActive: false })); });
                this.component.instance.cd.detectChanges();
            }
            if (!this.component.instance.isOpened) {
                return;
            }
            var input = this.el.nativeElement;
            if (!input) {
                return;
            }
            if (e.target === input || input.contains(e.target)) {
                return;
            }
            if (container &&
                container !== e.target &&
                !e.target.classList.contains('day') &&
                !container.contains(e.target)) {
                this.component.instance.isOpened = false;
            }
        };
        AirbnbCalendarDirective.prototype.onKeyup = function (ev) {
            if (!this.component.instance.isOpened) {
                return;
            }
            if (ev.keyCode === 27) {
                this.component.instance.isOpened = false;
                this.component.instance.cd.detectChanges();
                this.el.nativeElement.blur();
            }
        };
        return AirbnbCalendarDirective;
    }());
    AirbnbCalendarDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[airbnb-calendar]'
                },] }
    ];
    AirbnbCalendarDirective.ctorParameters = function () { return [
        { type: core.ComponentFactoryResolver },
        { type: core.ViewContainerRef },
        { type: core.ElementRef },
        { type: forms.NgModel }
    ]; };
    AirbnbCalendarDirective.propDecorators = {
        options: [{ type: core.Input }],
        onFocus: [{ type: core.HostListener, args: ['focus', ['$event.target'],] }],
        onBlurClick: [{ type: core.HostListener, args: ['document:click', ['$event'],] }],
        onKeyup: [{ type: core.HostListener, args: ['document:keyup', ['$event'],] }]
    };

    var AirbnbCalendarModule = /** @class */ (function () {
        function AirbnbCalendarModule() {
        }
        return AirbnbCalendarModule;
    }());
    AirbnbCalendarModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [AirbnbCalendarComponent, AirbnbCalendarDirective],
                    imports: [common.CommonModule, forms.FormsModule],
                    exports: [AirbnbCalendarComponent, AirbnbCalendarDirective],
                    entryComponents: [AirbnbCalendarComponent]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AirbnbCalendarComponent = AirbnbCalendarComponent;
    exports.AirbnbCalendarModule = AirbnbCalendarModule;
    exports.mergeCalendarOptions = mergeCalendarOptions;
    exports.ɵa = AirbnbCalendarDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-airbnb-calendar.umd.js.map
