import { ViewContainerRef, ComponentFactoryResolver, ComponentFactory, ElementRef, ComponentRef, OnChanges } from '@angular/core';
import { AirbnbCalendarComponent } from './airbnb-calendar.component';
import { Subscription } from 'rxjs';
import { NgModel } from '@angular/forms';
import { CalendarOptions } from './airbnb-calendar.interface';
export declare class AirbnbCalendarDirective implements OnChanges {
    private cfr;
    private vc;
    private el;
    private ngModel;
    options: CalendarOptions;
    component: ComponentRef<AirbnbCalendarComponent>;
    componentFactory: ComponentFactory<AirbnbCalendarComponent>;
    sub: Subscription;
    constructor(cfr: ComponentFactoryResolver, vc: ViewContainerRef, el: ElementRef, ngModel: NgModel);
    ngOnChanges(): void;
    onFocus(): void;
    onBlurClick(e: MouseEvent): void;
    onKeyup(ev: KeyboardEvent): void;
}
